package org.jboss.profileservice.mock.ds;

import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.jboss.util.xml.DOMUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class TestParse
{
   public static void main(String[] args)
      throws Exception
   {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      File tst = new File("/tmp/hsqldb-dsf.xml");
      Document document = builder.parse(tst);
      
      NodeList datasources = document.getElementsByTagName("local-tx-datasource");
      System.out.println("Found "+datasources.getLength()+" local-tx-datasources");
      for (int i = 0; i < datasources.getLength(); ++i)
      {
         Node node = datasources.item(i);
         System.out.println(i+": "+node);
         if (node.getNodeType() == Node.ELEMENT_NODE)
         {
            Element e = (Element) node;
            System.out.println("ELEMENT_NODE: "+e);
            NodeList tags = node.getChildNodes();
            for(int j = 0; j < tags.getLength(); j ++)
            {
               Node child = tags.item(j);
               if(child.getNodeType() == Node.ELEMENT_NODE)
               {
                  Element ej = (Element) child;
                  if (ej.getTagName().equals("jndi-name"))
                  {
                     System.out.println("jndi-name: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("user-name"))
                  {
                     System.out.println("user-name: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("driver-class"))
                  {
                     System.out.println("driver-class: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("password"))
                  {
                     System.out.println("password: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("min-pool-size"))
                  {
                     System.out.println("min-pool-size: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("max-pool-size"))
                  {
                     System.out.println("max-pool-size: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("security-domain"))
                  {
                     System.out.println("security-domain: "+DOMUtils.getTextContent(ej));
                  }
                  else if (ej.getTagName().equals("metadata"))
                  {
                     NodeList tms = ej.getElementsByTagName("type-mapping");
                     Element tm = (Element) tms.item(0);
                     System.out.println("metadata: "+tm.getTextContent());
                  }
                  else if (ej.getTagName().equals("depends"))
                  {
                     System.out.println("depends: "+DOMUtils.getTextContent(ej));
                  }
               }
            }
         }
      }
   }
}
